
#include <Acl/AclI.h>

AclI::AclI()
{

}

AclI::AclI(const Ice::Identity& id)
{
	this->id=id;
}

bool AclI::addEntity(const std::string& method,const Ice::Identity& usuario,const Ice::Current&)
{
	IceUtil::RWRecMutex::WLock sync(*this);
	bool retval=false;
	AccesMap::iterator it;
	it=acces.find(method);
	if(it!=acces.end())
	{
		EntityRefs entidades=(*it).second;
		EntityRefs::iterator itIds;
		itIds=find((*it).second.begin(),(*it).second.end(),usuario);
		if(itIds==(*it).second.end())
		{
			(*it).second.push_back(usuario);
			retval=true;
		}
	}
	return retval;
}

bool AclI::delEntity(const std::string& method,const Ice::Identity& usuario,const Ice::Current&)
{
	IceUtil::RWRecMutex::WLock sync(*this);
	bool retval=false;
	AccesMap::iterator it;
	it=acces.find(method);
	if(it!=acces.end())
	{
		cout<<"Go to delete entidad in method "<<method<<endl;
		EntityRefs::iterator itIds;
		itIds=find((*it).second.begin(),(*it).second.end(),usuario);
		if(itIds!=(*it).second.end())
		{
			(*it).second.erase(itIds);
			retval=true;
		}
	}
	return retval;
}

EntityRefs AclI::getEntities(const string& method,const Ice::Current&)const
{
	IceUtil::RWRecMutex::RLock sync(*this);
	EntityRefs entidades;
	AccesMap::const_iterator it;
	it=acces.find(method);
	if(it!=acces.end())
	{
		entidades=(*it).second;
	}
	return entidades;
}

Ice::Identity AclI::getOwmner(const Ice::Current&)const
{
	IceUtil::RWRecMutex::RLock sync(*this);
	cout<<"AclI::getOwmner"<<endl;
	return owmner;
}

bool AclI::chown(const Ice::Identity& usuario,const Ice::Current&)
{
	IceUtil::RWRecMutex::WLock sync(*this);
	owmner=usuario;
	return true;
}

bool AclI::auth(const Ice::Current& current)const
{
	IceUtil::RWRecMutex::RLock sync(*this);


	Ice::CommunicatorPtr ic=current.adapter->getCommunicator();

	Ice::Context::const_iterator it_ctx;

	string authType;	//type of auth
	string method;		//Method name that must be check
	//UserPrx userPx;		//Proxy to the user that's make the request

	//Search Auth paramenters in current.ctx

	it_ctx=current.ctx.find("authType");
	if(it_ctx!=current.ctx.end())
		authType=(*it_ctx).second;

	it_ctx=current.ctx.find("method");
	if(it_ctx!=current.ctx.end())
		method=(*it_ctx).second;

	/*it_ctx=current.ctx.find("user");
	if(it_ctx!=current.ctx.end())
	{
		string user=(*it_ctx).second;
		userPx=UserPrx::uncheckedCast(ic->stringToProxy(user));
	}*/

	bool retval=false;
	return retval;
}

bool AclI::setDefaultAcl(const Ice::Current&)
{
	IceUtil::RWRecMutex::WLock sync(*this);
	return true;
}


bool AclI::addMethod(const std::string& method,const Ice::Current&)
{
	IceUtil::RWRecMutex::WLock sync(*this);
	bool retval=false;
	AccesMap::iterator it;
	it=acces.find(method);
	if(it==acces.end())
	{
		EntityRefs entidades;
		acces[method]=entidades;
		retval=true;
	}
	return retval;
}

bool AclI::delMethod(const std::string& method,const Ice::Current&)
{
	IceUtil::RWRecMutex::WLock sync(*this);
	bool retval=false;
	AccesMap::iterator it;
	it=acces.find(method);
	if(it!=acces.end())
	{
		acces.erase(it);
		retval=true;
	}
	return retval;
}

Strings AclI::getMethods(const Ice::Current&)const
{
	cout<<"AclI getMethods"<<endl;
	IceUtil::RWRecMutex::RLock sync(*this);
	Strings methods;
	AccesMap::const_iterator it;
	for(it=acces.begin();it!=acces.end();it++)
		methods.push_back((*it).first);
	cout<<"AclI getMethods OK"<<endl;
	return methods;
}

