// **********************************************************************
//
// Copyright (c) 2003-2004 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 1.5.1
// Generated from file `Base.ice'

#include <Acl/Base.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 10501
#       error Ice version mismatch!
#   endif
#endif

void
__write(::IceInternal::BasicStream* __os, const ::StringMap& v, ::__U__StringMap)
{
    __os->writeSize(::Ice::Int(v.size()));
    ::StringMap::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
	__os->write(p->first);
	__os->write(p->second);
    }
}

void
__read(::IceInternal::BasicStream* __is, ::StringMap& v, ::__U__StringMap)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    while(sz--)
    {
	::std::pair<const  ::std::string, ::std::string> pair;
	__is->read(const_cast< ::std::string&>(pair.first));
	::StringMap::iterator __i = v.insert(v.end(), pair);
	__is->read(__i->second);
    }
}

void
__write(::IceInternal::BasicStream* __os, const ::EntityRefs& v, ::__U__EntityRefs)
{
    __os->writeSize(::Ice::Int(v.size()));
    ::EntityRefs::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
	(*p).__write(__os);
    }
}

void
__read(::IceInternal::BasicStream* __is, ::EntityRefs& v, ::__U__EntityRefs)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    __is->startSeq(sz, 2);
    v.resize(sz);
    for(int i = 0; i < sz; ++i)
    {
	v[i].__read(__is);
	__is->checkSeq();
	__is->endElement();
    }
    __is->endSeq(sz);
}

void
__write(::IceInternal::BasicStream* __os, const ::AccesMap& v, ::__U__AccesMap)
{
    __os->writeSize(::Ice::Int(v.size()));
    ::AccesMap::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
	__os->write(p->first);
	::__write(__os, p->second, ::__U__EntityRefs());
    }
}

void
__read(::IceInternal::BasicStream* __is, ::AccesMap& v, ::__U__AccesMap)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    while(sz--)
    {
	::std::pair<const  ::std::string, ::EntityRefs> pair;
	__is->read(const_cast< ::std::string&>(pair.first));
	::AccesMap::iterator __i = v.insert(v.end(), pair);
	::__read(__is, __i->second, ::__U__EntityRefs());
    }
}

void
__write(::IceInternal::BasicStream* __os, const ::StringProxyMap& v, ::__U__StringProxyMap)
{
    __os->writeSize(::Ice::Int(v.size()));
    ::StringProxyMap::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
	__os->write(p->first);
	::__write(__os, p->second);
    }
}

void
__read(::IceInternal::BasicStream* __is, ::StringProxyMap& v, ::__U__StringProxyMap)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    while(sz--)
    {
	::std::pair<const  ::std::string, ::OnRezPrx> pair;
	__is->read(const_cast< ::std::string&>(pair.first));
	::StringProxyMap::iterator __i = v.insert(v.end(), pair);
	::__read(__is, __i->second);
    }
}

void
__write(::IceInternal::BasicStream* __os, const ::TopicsMap& v, ::__U__TopicsMap)
{
    __os->writeSize(::Ice::Int(v.size()));
    ::TopicsMap::const_iterator p;
    for(p = v.begin(); p != v.end(); ++p)
    {
	__os->write(p->first);
	::IceStorm::__write(__os, p->second);
    }
}

void
__read(::IceInternal::BasicStream* __is, ::TopicsMap& v, ::__U__TopicsMap)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    while(sz--)
    {
	::std::pair<const  ::std::string, ::IceStorm::TopicPrx> pair;
	__is->read(const_cast< ::std::string&>(pair.first));
	::TopicsMap::iterator __i = v.insert(v.end(), pair);
	::IceStorm::__read(__is, __i->second);
    }
}
