
#include <OnRez/XmlRequest.h>

XmlRequest::XmlRequest()
{
	sessionId.name="";
	sessionId.category="";	
	actionType="R";
	method="";
	proxy="";
	status="NoReady";
	atts.clear();
}
Ice::Identity XmlRequest::getSessionId()
{
	return sessionId;
}

QString XmlRequest::getActionType()
{
	return actionType;
}

QString XmlRequest::getMethod()
{
	return method;
}

QString XmlRequest::getProxy()
{
	return proxy;
}

QString XmlRequest::getAtt(QString name)
{
	StringMap::const_iterator it;
	QString sValue="";
 	it=atts.find(name.latin1());
	if(it!=atts.end())
	{
		sValue=(*it).second.c_str();
	}
	return sValue;
}

QString XmlRequest::getStatus()
{
	return status;
}


/*	toWeb XmlRequest

	<Request sessionId="45454">
		<Object proxy="192" method="W"/>
		<Method name="addUser">
			<params>
				<param value="true" name="actived"/>
				<param value="100" name="prize"/>
				<param value="Gutierez" name="clienPx"/>
			</params>
		</Method>
	</Request>
*/

void XmlRequest::load(QString xml)
{
	status="Loading";
	QDomDocument xmlRequest("XmlRequest");
	if(xmlRequest.setContent(xml))
	{
		QDomNode requestNode=xmlRequest.documentElement();
		QDomElement requestElement = requestNode.toElement(); // try to convert the node to an element.
		
		if((!requestElement.isNull())&&(requestElement.tagName()=="Request")) 
		{
			if(requestElement.hasAttribute("sessionId"))
			{
				this->sessionId=Ice::stringToIdentity(requestElement.attributeNode("sessionId").value().latin1());
				
				QDomNode objectNode=requestNode.firstChild();
				QDomElement objectElement=objectNode.toElement();
				if((!objectElement.isNull())&&(objectElement.tagName()=="Object"))
				{
					if(objectElement.hasAttribute("proxy"))
					{
						proxy=objectElement.attributeNode("proxy").value().latin1();
					}
					else
					{
						status="Error";
					}
					
					if((status=="Loading")&&(objectElement.hasAttribute("method")))
					{
						actionType=objectElement.attributeNode("method").value().latin1();
					}
					else
					{
						status="Error";
					}
				}
				else
				{
					status="Error";
				}
				
				QDomNode methodNode=objectNode.nextSibling();
				QDomElement methodElement=methodNode.toElement();
				if((status="Loading")&&(!methodElement.isNull())&&(methodElement.tagName()=="Method"))
				{
					if((status=="Loading")&&(methodElement.hasAttribute("name")))
					{
						method=methodElement.attributeNode("name").value().latin1();
						std::cout<<"Loading Method: "<<method<<std::endl;
					}
					
					else
					{
						std::cout<<"Error loading Method"<<endl;
						status="Error";
					}
					
					QDomNode paramsNode=methodNode.firstChild();
					QDomElement paramsElement=paramsNode.toElement();
					
					if((status=="Loading")&&(!paramsElement.isNull())&&(paramsElement.tagName()=="params"))
					{
						QDomNode paramNode=paramsNode.firstChild();
						std::cout<<"Load Atts: "<<std::endl;                
						while(!paramNode.isNull())
						{
							QDomElement paramElement=paramNode.toElement();
							if((!paramElement.isNull())&&(paramElement.tagName()=="param"))
							{
								if((paramElement.hasAttribute("name"))&&((paramElement.hasAttribute("value"))))
								{
									string pName=paramElement.attributeNode("name").value().latin1();
									string pValue=paramElement.attributeNode("value").value().latin1();
									atts[pName]=pValue;
									std::cout<<"add att name: "<<pName<<" value: "<<pValue<<std::endl;
								}
								
							}
							paramNode=paramNode.nextSibling();
						}
						status="Ready";
					}
					
					else
					{
						status="Error";
					}
				}
				else
				{
					status="Error";
				}	
			}
			else
			{
				status="Error";
			}
		}
	}
	else
	{
		status="Error";
	}
}
	
